<id>
Return To for YaBB 2.5
</id>

<version>
1.1
</version>

<mod info>
Description
-----------
This mod allows users to decide where to return to after posting. A drop-down selection box is placed underneath the 'Disable UBBC and Smilies' check box on the post page. Users may select to return to the current thread, current board, or the forum index. Members can also select a default selection for this feature in their profile.

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.

Files to edit
-------------
Admin/ModList.pl
Sources/ModifyMessage.pl
Sources/Post.pl
Sources/Profile.pl
Sources/System.pl

Version History
---------------
### YaBB 2.4/2.5 - Derek Barnstorm ###
v1.0 - Updated for YaBB 2.4 - 27th August 2009
v1.0a - Fixed issue with new posts indicator flashing if returning to forum index - 1st September 2009
v1.0b - Removed Return To from Broadcast Message to Admin and Alert Moderator - 30th September 2009
v1.1 - Updated for YaBB 2.5 and fixed bug with incrementing thread views - 7th May 2012

### YaBB 2.1 - astro-pilot ###
v1.0 - Initial Release - 11th October 2005
v1.1 - Added the ability for a user to select which 'return to' area would be selected in the drop down menu as default in their profile options.  Also, removed workaround for 'new' marker with actual fix and extended this to new threads also.
v1.2 - Fixed issue with threads that will notify other users when posted to.
</mod info>

<author>
astro-pilot
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/Modlist.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$return_to_mod = "Return To|astro-pilot|This mod allows users to decide where to return to after posting. A drop-down selection box is placed underneath the 'Disable UBBC and Smilies' check box on the post page. Users may select to return to the current thread, current board, or the forum index. Members can also select a default selection for this feature in their profile.|1.1|7th May 2012";
	push (@installed_mods, "$return_to_mod");
	
</add before>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
	$yySetLocation = qq~$scripturl?num=$threadid/$start#$postid~;
</search for>

<replace>
    ### Return To mod start ###
    my $rts = $FORM{'return_to'};		
    if ($rts == 3) {
        $yySetLocation = qq~$scripturl~;
    } elsif ($rts == 2) {
        $yySetLocation = qq~$scripturl?board=$currentboard~;
    } else { 
        $yySetLocation = qq~$scripturl?num=$threadid/$start#$postid~;
    }	
    ### Return To mod end ###
</replace>

<edit file>
Sources/Post.pl
</edit file>

<search for>
		# /File Attachment's Browse Box Code
</search for>

<add after>

    ### Return To mod start ###
    &LoadLanguage('Return_To');
    my ($rts, $rt, $return_to_select, $return_to);
    $rts = $FORM{'return_to'} ? $FORM{'return_to'} : ${$uid.$username}{'return_to'};
    for ($rt = 1; $rt <= 3; $rt++) {
         $return_to_select .= $rts == $rt ? qq~<option value="$rt" selected="selected">$return_to_txt{$rt}</option>~ : qq~<option value="$rt">$return_to_txt{$rt}</option>~;
    }
    if ($destination ne 'modalert2' && $destination ne 'guestpm2') {
        $return_to = qq~      
    <tr id="feature_status_9">
        <td class="windowbg" width="23%"><label for="return_to"><b>$return_to_txt{'01'}:</b></label></td>
        <td class="windowbg" width="77%"><select name="return_to" id="return_to" size="1">$return_to_select</select> <span class="small"><label for="return_to">$return_to_txt{'02'}</label></span></td>
    </tr>~;
    }
    ### Return To mod end ###
</add after>

<search for>
			<input type="checkbox" name="ns" id="ns" value="NS"$nscheck /> <span class="small"> <label for="ns">$post_txt{'277'}</label></span>
		</td>
	</tr>
</search for>

<add after>
    <!-- ### Return To mod start ### -->
    $return_to 
    <!-- ### Return To mod end ### -->
</add after>

<search for>
	if ($currentboard eq $annboard) {
		$yySetLocation = qq~$scripturl?virboard=$FORM{'virboard'};num=$thread/$start#$mreplies~;
	} else {
		$yySetLocation = qq~$scripturl?num=$thread/$start#$mreplies~;
	}
</search for>

<replace>
    ### Return To mod start ###
    my $rts = $FORM{'return_to'};		
    if ($rts == 3) {
        $yySetLocation = qq~$scripturl~; 
        &dumplog($currentboard, $date);
        &dumplog($thread, $date);
        if (!$INFO{'num'}) { &MessageTotals("incview", $thread); }
    } elsif ($rts == 2) {
        $yySetLocation = qq~$scripturl?board=$currentboard~;
        &dumplog($thread, $date);
        if (!$INFO{'num'}) { &MessageTotals("incview", $thread); }
    } else { 
        if ($currentboard eq $annboard) {
            $yySetLocation = qq~$scripturl?virboard=$FORM{'virboard'};num=$thread/$start#$mreplies~;
        } else { 
            $yySetLocation = qq~$scripturl?num=$thread/$start#$mreplies~;
        }	
    }
    ### Return To mod end ###
</replace>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
		<td align="left" valign="top"><input type="checkbox" name="reversetopic" id="reversetopic"~ . (${$uid.$user}{'reversetopic'} ? qq~ checked="checked"~ : '') . qq~ /></td>
	</tr>~;
	}
</search for>

<add after>

    ### Return To mod start ###
    &LoadLanguage('Return_To');
    my ($rts, $rt, $return_to_select, $return_to);
    $rts = ${$uid.$user}{'return_to'};
    for ($rt = 1; $rt <= 3; $rt++) {
         $return_to_select .= $rts == $rt ? qq~<option value="$rt" selected="selected">$return_to_txt{$rt}</option>~ : qq~<option value="$rt">$return_to_txt{$rt}</option>~;
    }
    $showProfile .= qq~      
    <tr class="windowbg">
        <td align="left"><label for="return_to"><b>$return_to_txt{'01'}:</b><br /><span class="small">$return_to_txt{'03'}</span></label></td>
        <td align="left"><select name="return_to" id="return_to" size="1">$return_to_select</select></td>
    </tr>~;	
    ### Return To mod end ###
</add after>

<search for>
	${$uid.$user}{'numberformat'} = int($member{'usernumberformat'});
</search for>

<add after>
    ${$uid.$user}{'return_to'} = $member{'return_to'}; ### Return To mod ###
</add after>

<edit file>
Sources/System.pl
</edit file>

<search for>
	if ($extendedprofiles) {
		require "$sourcedir/ExtendedProfiles.pl";
</search for>

<add before>
	push(@tags, "return_to"); ### Return To mod ###
</add before>
